<?php

class AddressattributeModel {
  public $address_id = null;
  public $name = null;
  public $value = null;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  
  public static function create(Array $data) {
    $model = new Addressattribute();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();
    
    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($idOrFilter) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $db = FronkDB::singleton();
    
    $res = $db->select("Addressattribute", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Addressattribute($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function getAll($filter = false) {
    $items = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("Addressattribute", "*", "1=1 ORDER BY address_id ASC, name");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Addressattribute($data);
      }
    }
    return $items;
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    $where = self::getSqlFilter($filter);
    $sql = "SELECT Addressattribute.* FROM Addressattribute
            WHERE $where
            ORDER BY address_id ASC, name";
    //var_dump($sql);
    $res = $db->query($sql);
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Addressattribute($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $sql = "SELECT Addressattribute.* FROM Addressattribute
            WHERE $where
            ORDER BY address_id ASC, name";
    //var_dump($sql);
    $res = $db->query($sql);
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {  
        $items[] = new Addressattribute($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    
    if(array_key_exists("address_id", $filter)) {
      $address_id = $filter['address_id'];
      if(!is_numeric($address_id) || !$address_id) {
        return false;
      }
      
      $where .= " AND address_id=$address_id";
    }
    
    if(array_key_exists("name", $filter)) {
      $name = FronkDB::singleton()->escape($filter['name']);
      if($name) {
        $where .= " AND `name`='$name'";
      }
    }
    
    return $where;
  }
}